/*******************************************************\
* modlisation d'une surface d'eau                      *
* GLVector.cpp											*
* ------------------------------------------------------*
* Georges AZZI / Georges CAMY                           * 
* Julie POULETTY / Arnaud QUENUM                        *
* IMAC Ing3 2002/2003 - Universit de Marne La Valle  *
* Copyright 2003                                        *
\*******************************************************/
#include "GLVector.h"



/*******************************************************\
*                    constructeurs                      *
\*******************************************************/
GLVector::GLVector(){
	x = 0;
	y = 0;
	z = 0;
}

GLVector::GLVector(GLdouble newX, GLdouble newY, GLdouble newZ){
	x = newX;
	y = newY;
	z = newZ;
}



/*******************************************************\
* Mthode:		setX, setY, setZ						*
* Description:  dfinit les valeurs x,y et z			*
\*******************************************************/
void GLVector::setX(GLdouble newX){
	x = newX;
}

void GLVector::setY(GLdouble newY){
	y = newY;
}

void GLVector::setZ(GLdouble newZ){
	z = newZ;
}



/*******************************************************\
* Mthode:		getX, getY, getZ						*
* Description:  fournit les valeurs x,y et z			*
\*******************************************************/
GLdouble GLVector::getX(){
	return x;
}

GLdouble GLVector::getY(){
	return y;
}

GLdouble GLVector::getZ(){
	return z;
}



/*******************************************************\
* Mthode:		+										*
* Description:  Addition vectorielle					*
\*******************************************************/
GLVector GLVector::operator+(const GLVector &a){
	GLVector copy(*this);

	copy.setX( copy.x + a.x );
	copy.setY( copy.y + a.y );
	copy.setZ( copy.z + a.z );
	return copy;
}



/*******************************************************\
* Mthode:		-										*
* Description:  Soustraction vectorielle				*
\*******************************************************/
GLVector GLVector::operator-(const GLVector &a){
	GLVector copy(*this);

	copy.setX( copy.x - a.x );
	copy.setY( copy.y - a.y );
	copy.setZ( copy.z - a.z );
	return copy;
}



/*******************************************************\
* Mthode:		*										*
* Description:  Produit scalaire						*
\*******************************************************/
GLVector GLVector::operator*(const double &a){
	GLVector copy(*this);

	copy.setX( copy.x * a);
	copy.setY( copy.y * a );
	copy.setZ( copy.z * a );
	return copy;
}


/*******************************************************\
* Mthode:		normalize								*
* Description:  retourne le vecteur norm				*
\*******************************************************/
GLVector GLVector::normalize(){
	double norm;
	GLVector copy(*this);
	
	norm = sqrt(x*x + y*y + z*z);
	copy.setX( x/norm);
	copy.setY( y/norm);
	copy.setZ( z/norm);
	return copy;
}



/*******************************************************\
* Mthode:		set2Zero								*
* Description:  annulle le vecteur						*
\*******************************************************/
void GLVector::set2Zero(){
	x = 0.0;
	y = 0.0;
	z = 0.0;
}
