/*******************************************************\
* modlisation d'une surface d'eau                      *
* GLVector.h		                                    *
* ------------------------------------------------------*
* Georges AZZI / Georges CAMY                           * 
* Julie POULETTY / Arnaud QUENUM                        *
* IMAC Ing3 2002/2003 - Universit de Marne La Valle  *
* Copyright 2003                                        *
\*******************************************************/
#ifndef GLVector_h
#define GLVector_h
#endif

#ifdef WIN32
#include <windows.h>
#endif

#include <math.h>

#ifndef M_PI
#define M_PI	3.1415926535897932384626433832795
#endif

#include <iostream.h>
#include <fstream.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>



/*******************************************************\
* Classe:		GLVector								*
* Description:  ceci reprsente un vecteur hyper-simple *
*				openGL ne fournit pas un tel type		*
*				apparemment								* 
\*******************************************************/
class GLVector{

public :
	GLVector();
	GLVector(GLdouble newX, GLdouble newY, GLdouble newZ);
	void setX(GLdouble newX);
	void setY(GLdouble newY);
	void setZ(GLdouble newZ);
	GLdouble getX();
	GLdouble getY();
	GLdouble getZ();
	GLVector operator+(const GLVector &a);
	GLVector operator-(const GLVector &a);
	GLVector operator*(const double &a);
	GLVector normalize();
	void set2Zero();

private:
	GLdouble x;
	GLdouble y;
	GLdouble z;
};



