/*******************************************************\
* modlisation d'une surface d'eau                      *
* TexturedCube.cpp                                      *
* ------------------------------------------------------*
* Georges AZZI / Georges CAMY                           * 
* Julie POULETTY / Arnaud QUENUM                        *
* IMAC Ing3 2002/2003 - Universit de Marne La Valle  *
* Copyright 2003                                        *
\*******************************************************/
#include "TexturedCube.h"



/*******************************************************\
*                    constructeur                       *
\*******************************************************/
TexturedCube::TexturedCube(){

  // dfinitions: matriaux
  float mat_ambi_or[]= {0.2,0.2,0.1},mat_diff_or[]= {0.8,0.8,0.2},
        mat_spec_or[]= {0.8,0.8,0.8},mat_nphong_or=20.0;


  // cration de l'objet texturedcube
  id_corps = glGenLists(1);
  glNewList(id_corps,GL_COMPILE);

  glPushMatrix();

  // face x
  glBegin(GL_QUADS);
  glTexCoord2d(0.0,0.0);
  glVertex3d(0.5,0.5,0.5);
  glTexCoord2d(1.0,0.0);
  glVertex3d(0.5,0.5,-0.5);
  glTexCoord2d(1.0,1.0);
  glVertex3d(0.5,-0.5,-0.5);
  glTexCoord2d(0.0,1.0);
  glVertex3d(0.5,-0.5,0.5);
  glEnd();
  // face -x
  glBegin(GL_QUADS);
  glTexCoord2d(0.0,0.0);
  glVertex3d(-0.5,0.5,0.5);
  glTexCoord2d(1.0,0.0);
  glVertex3d(-0.5,0.5,-0.5);
  glTexCoord2d(1.0,1.0);
  glVertex3d(-0.5,-0.5,-0.5);
  glTexCoord2d(0.0,1.0);
  glVertex3d(-0.5,-0.5,0.5);
  glEnd();
  // face y
  glBegin(GL_QUADS);
  glTexCoord2d(0.0,0.0);
  glVertex3d(-0.5,0.5,0.5);
  glTexCoord2d(1.0,0.0);
  glVertex3d(-0.5,0.5,-0.5);
  glTexCoord2d(1.0,1.0);
  glVertex3d(0.5,0.5,-0.5);
  glTexCoord2d(0.0,1.0);
  glVertex3d(0.5,0.5,0.5);
  glEnd();
  // face -y
  glBegin(GL_QUADS);
  glTexCoord2d(0.0,0.0);
  glVertex3d(-0.5,-0.5,0.5);
  glTexCoord2d(1.0,0.0);
  glVertex3d(-0.5,-0.5,-0.5);
  glTexCoord2d(1.0,1.0);
  glVertex3d(0.5,-0.5,-0.5);
  glTexCoord2d(0.0,1.0);
  glVertex3d(0.5,-0.5,0.5);
  glEnd();
  // face z
  glBegin(GL_QUADS);
  glTexCoord2d(0.0,0.0);
  glVertex3d(-0.5,0.5,0.5);
  glTexCoord2d(1.0,0.0);
  glVertex3d(0.5,0.5,0.5);
  glTexCoord2d(1.0,1.0);
  glVertex3d(0.5,-0.5,0.5);
  glTexCoord2d(0.0,1.0);
  glVertex3d(-0.5,-0.5,0.5);
  glEnd();
  // face -z
  glBegin(GL_QUADS);
  glTexCoord2d(0.0,0.0);
  glVertex3d(-0.5,0.5,-0.5);
  glTexCoord2d(1.0,0.0);
  glVertex3d(0.5,0.5,-0.5);
  glTexCoord2d(1.0,1.0);
  glVertex3d(0.5,-0.5,-0.5);
  glTexCoord2d(0.0,1.0);
  glVertex3d(-0.5,-0.5,-0.5);
  glEnd();

  glPopMatrix();

  // fin de dclaration de l'objet solidCube
  glEndList();
}



/*******************************************************\
* Mthode:		dessiner								*
* Description:  dessine le cube                         *
\*******************************************************/
void TexturedCube::dessiner(GLdouble size){
   glPushMatrix();
   glScalef(size,size,size);
   glCallList(id_corps);
   glPopMatrix();
}

