/*******************************************************\
* modlisation d'une surface d'eau                      *
* WaterPoint.cpp										*
* ------------------------------------------------------*
* Georges AZZI / Georges CAMY                           * 
* Julie POULETTY / Arnaud QUENUM                        *
* IMAC Ing3 2002/2003 - Universit de Marne La Valle  *
* Copyright 2003                                        *
\*******************************************************/
#include "WaterPoint.h"



/*******************************************************\
*                    constructeur                       *
\*******************************************************/
WaterPoint::WaterPoint(){
	x = 0;
	y = 0;
	z = 0;
	speed.set2Zero();
}



WaterPoint::WaterPoint(GLdouble newX, GLdouble newY, GLdouble newZ){
	x = newX;
	y = newY;
	z = newZ;
	speed.set2Zero();
}


/*******************************************************\
* Mthode:		setPosition								*
* Description:  dfinit les coordonnes				    *
\*******************************************************/
void WaterPoint::setPosition(GLVector p){
	x = p.getX();
	y = p.getY();
	z = p.getZ();
}


void WaterPoint::setPosition(GLdouble newX, GLdouble newY, GLdouble newZ){
	x = newX;
	y = newY;
	z = newZ;
}



/*******************************************************\
* Mthode:		setSpeed								*
* Description:  dfinit la vitesse du point				*
\*******************************************************/
void WaterPoint::setSpeed(GLVector p){
	speed = p;
}



/*******************************************************\
* Mthode:		getPosition								*
* Description:  fournit la position0 du point			*
\*******************************************************/
GLVector WaterPoint::getPosition(){
	return GLVector(x, y, z);
}



/*******************************************************\
* Mthode:		getSpeed								*
* Description:  fournit la vitesse du point				*
\*******************************************************/
GLVector WaterPoint::getSpeed(){
	return speed;
}



/*******************************************************\
* Mthode:		getSumOfForces							*
* Description:  fournit la somme des forces appliqus	*
\*******************************************************/
GLVector WaterPoint::getSumOfForces(){
	return sumOfForces;
}



/*******************************************************\
* Mthode:		addForce								*
* Description:  applique une force sur le point			*
\*******************************************************/
void WaterPoint::addForce(GLVector force){
	sumOfForces = sumOfForces + force;
}



/*******************************************************\
* Mthode:		update									*
* Description:  calcule la nouvelle position  partir	* 
*				de la vitesse et des forces appliqus	*
\*******************************************************/
void WaterPoint::update(){
	speed = speed + sumOfForces;
	x = x + speed.getX();
	y = y + speed.getY();
	z = z + speed.getZ();
	sumOfForces.set2Zero();
}




/*******************************************************\
* Mthode:		dessiner								*
* Description:  dessine le point 			            *
\*******************************************************/
void WaterPoint::dessiner(){
	glVertex3d(x,y,z);
}




/*******************************************************\
* Mthode:		distanceVector							*
* Description:  retourne le vecteur qui translaterait 	* 
*				ce point vers le point donn en         *
*				argument								*
\*******************************************************/
GLVector WaterPoint::distanceVector(WaterPoint p){
	GLVector v;

	v = p.getPosition() - getPosition();
	return v;
}