/*******************************************************\
* modlisation d'une surface d'eau                      *
* WaterPoint.h		                                    *
* ------------------------------------------------------*
* Georges AZZI / Georges CAMY                           * 
* Julie POULETTY / Arnaud QUENUM                        *
* IMAC Ing3 2002/2003 - Universit de Marne La Valle  *
* Copyright 2003                                        *
\*******************************************************/
#ifndef WaterPoint_h
#define WaterPoint_h
#endif

#ifdef WIN32
#include <windows.h>
#endif

#include <math.h>

#ifndef M_PI
#define M_PI	3.1415926535897932384626433832795
#endif

#include <iostream.h>
#include <fstream.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>

#include "GLVector.h"



/*******************************************************\
* Classe:		WaterPoint								*
* Description:  reprsente un point de la grille		* 
\*******************************************************/
class WaterPoint{

public :
	WaterPoint();
	WaterPoint(GLdouble newX, GLdouble newY, GLdouble newZ);
	void setPosition(GLVector p);
	void setPosition(GLdouble newX, GLdouble newY, GLdouble newZ);
	void setSpeed(GLVector p);
	GLVector getPosition();
	GLVector getSpeed();
	GLVector getSumOfForces();
	void addForce(GLVector force);
	void update();
	void dessiner();
	GLVector distanceVector(WaterPoint p);

private:
	GLdouble x, y, z;
	GLVector sumOfForces;
	GLVector speed;
};



