/*******************************************************\
* modlisation d'une surface d'eau                      *
* WaterSurface.h                                        *
* ------------------------------------------------------*
* Georges AZZI / Georges CAMY                           * 
* Julie POULETTY / Arnaud QUENUM                        *
* IMAC Ing3 2002/2003 - Universit de Marne La Valle  *
* Copyright 2003                                        *
\*******************************************************/
#ifndef WaterSurface_h
#define WaterSurface_h
#endif

#ifdef WIN32
#include <windows.h>
#endif

#include <math.h>

#ifndef M_PI
#define M_PI	3.1415926535897932384626433832795
#endif

#include <iostream.h>
#include <fstream.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>

#ifndef WaterPoint_h
#include "WaterPoint.h"
#endif
#ifndef WaterExciter_h
#include "WaterExciter.h"
#endif



/*******************************************************\
* Classe:		WaterSurface							*
* Description:  eh ben... la surface de l'eau!!!		* 
\*******************************************************/
class WaterSurface{

public :
	WaterSurface(GLint newLength, GLint newWidth);
	void reset();
	void setModel(GLint model);
	void applyForce(GLVector force, GLint i, GLint j);
	void setK(GLdouble x);
	GLdouble getK();
	GLdouble getFriction();
	void setFriction(GLdouble x);
	void setExciter(GLint exciter, GLVector force, bool frequency);
	void clearExciter(GLint exciter);
	void dessiner();

private:
	void update4SpringModel();
	void update8SpringModel();
	void update4SpringVerticalModel();
	WaterPoint surface[40][30];
	GLint length;
	GLint width;
	GLint model;
	GLdouble k;
	GLdouble friction;
	GLdouble time;
	// texture
	int dx,dy;
	unsigned char *image;
	GLuint id_texture;
	bool texture;
};



