/*******************************************************\
* modlisation d'une surface d'eau                      *
* WaterSurface2.h                                        *
* ------------------------------------------------------*
* Georges AZZI / Georges CAMY                           * 
* Julie POULETTY / Arnaud QUENUM                        *
* IMAC Ing3 2002/2003 - Universit de Marne La Valle  *
* Copyright 2003                                        *
\*******************************************************/
#ifndef WaterSurface2_h
#define WaterSurface2_h
#endif

#ifdef WIN32
#include <windows.h>
#endif

#include <math.h>

#ifndef M_PI
#define M_PI	3.1415926535897932384626433832795
#endif

#include <iostream.h>
#include <fstream.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>

#ifndef WaterPoint_h
#include "WaterPoint.h"
#endif
#ifndef WaterExciter_h
#include "WaterExciter.h"
#endif


/*******************************************************\
* Classe:		WaterSurface2				*
* Description:  eh ben... la surface de l'eau!!!	*
*               cette fois-ci en version Piranda	* 
\*******************************************************/
class WaterSurface2{

public :
	WaterSurface2(GLint newLength, GLint newWidth);
	void reset();
	void setK(GLdouble x);
	GLdouble getK();
	GLdouble getFriction();
	void setFriction(GLdouble x);
	GLdouble getMass();
	void setMass(GLdouble x);
	void update();
	void dessiner();

private:
	GLdouble z[40][30];
	GLdouble nz[40][30];
	GLdouble v[40][30];
	GLdouble nv[40][30];	
	GLint length;
	GLint width;
	GLdouble mass;
	GLdouble k;
	GLdouble friction;
	GLdouble time;
};


