/*******************************************************\
* modlisation d'une surface d'eau                      *
* ocean.cpp                                             *
* ------------------------------------------------------*
* Georges AZZI / Georges CAMY                           * 
* Julie POULETTY / Arnaud QUENUM                        *
* IMAC Ing3 2002/2003 - Universit de Marne La Valle  *
* Copyright 2003                                        *
\*******************************************************/

#include "ocean.h"


/*******************************************************\
*               Dfinitions: Makros                     *
\*******************************************************/
// Taille du tampon de la slection
#define _SELECTION_BUFFER_SIZE 1024

// souris
#define _MOUSE_WHEEL_UP 3
#define _MOUSE_WHEEL_DOWN 4



/*******************************************************\
*               Dfinitions: fentre                    *
\*******************************************************/
int windowWidth=1200;
int windowHeight=800;
GLfloat windowRapport;



/*******************************************************\
*               Dfinitions: commandes                  *
\*******************************************************/
bool aide = true;
bool showFps = true; //false;
GLdouble fps = 0;
bool texture = true;
bool reperesSpots = false;
GLint modele = 5;



/*******************************************************\
*          Dfinitions: variables de mouvement          *
\*******************************************************/
GLdouble temps = glutGet(GLUT_ELAPSED_TIME);



/*******************************************************\
*               Dfinitions: camra                     *
\*******************************************************/
GLdouble thetaOeil=6.963, phiOeil=-3.5996, distOeil=10.0;
GLdouble oeilx=distOeil*cos(thetaOeil)*cos(phiOeil),
         oeily=distOeil*sin(thetaOeil)*cos(phiOeil),
		 oeilz=distOeil*sin(phiOeil),
		 visex=0.0,
		 visey=0.0,
		 visez=0.5;

// abscisse du clic
int xold;
// ordonne du clic
int yold, y_zoom_old;
//'vitesse' de mouvance
int dist_x, dist_y, dist_yzoom;

// zoom
GLdouble zoom = 0.2;

//Boutons de la souris
bool left, right;



/*******************************************************\
*               Dfinitions: lumires                   *
\*******************************************************/

// lumire 0 : lumire ambiante
GLfloat Light0Pos[4]  = {0.0,10.0,0.0,1.0};
GLfloat Light0Amb[4]  = {0.4, 0.4, 0.4, 0.3};
GLfloat Light0Dif[4]  = {0.8, 0.8, 0.8, 0.3};
GLfloat Light0Spec[4] = {0.3, 0.3, 0.3, 0.01};




/*******************************************************\
*     Dfinitions: pointeurs sur les objets             *
\*******************************************************/
Repere *mon_repere;
WaterSurface *ma_waterSurface;
WaterSurface2 *ma_waterSurface2;
WaterSurface3 *ma_waterSurface3;



/*******************************************************\
*             Prototypes des fonctions                  *
\*******************************************************/
static void drawFunc(void);
static void reshapeFunc(int w,int h);
static void kbdFunc(unsigned char c, int x, int y);
static void kbdSpecialFunc(int c, int x, int y);
static void mouseFunc(int button, int state, int x, int y);
static void motionFunc(int x, int y);
static void idleFunc();
void dessinerSceneNommee();
void processHits(GLint hits, GLuint buffer[]);
void selection(int x, int y);
static void init();
void credits (void);
int main(int argc, char** argv);



/*******************************************************\
* Fonction:		drawFunc                                *
* Description:  dessine la scne  l'cran              *
\*******************************************************/
static void drawFunc(void){
  // Tampons texte
  char textBuffer1[100];

  // initialisation des buffers : couleur et ZBuffer
  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

  // modification de la matrice de la scne
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();

  // lumire 0 : globale diffuse
  glLightfv(GL_LIGHT0, GL_POSITION,Light0Pos);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, Light0Dif);
  glLightfv(GL_LIGHT0, GL_SPECULAR,Light0Spec);
  glLightfv(GL_LIGHT0, GL_AMBIENT, Light0Amb);

  // placement de la scne en fonction de la camra
  gluLookAt(oeilx,oeily,oeilz,visex,visey,visez,0.0,0.0,1.0);

  // Zoom
  glScalef(zoom,zoom,zoom);

  // lumires

  // repere
  //mon_repere->dessiner();

  // surface d'eau
  glTranslatef(-20,-15,0);
  switch(modele){
      // modles  4, 8, 4vert ressorts
      case 1: case 2: case 3:
	    ma_waterSurface->dessiner();
        break;
      // modle Piranda    
      case 4:
         temps = glutGet(GLUT_ELAPSED_TIME);
         int i;
         i=0;
	     do{
		    ma_waterSurface2->update();
		    //cout << "i = " << i << "     temps = "<< glutGet(GLUT_ELAPSED_TIME) - temps  << endl;
		    i++;
	      } while  ( (i<100) && ( (glutGet(GLUT_ELAPSED_TIME) - temps) < 40) );
	      ma_waterSurface2->dessiner();
          break;
      // modle ocanographique
      case 5:
        ma_waterSurface3->update();
        ma_waterSurface3->dessiner();
        break;
  }
  
  
  // fin de la partie 3D. Voir plus haut "modification de la matrice de la scne"
  glPopMatrix();


  // 2D Text
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
	glLoadIdentity();
	gluOrtho2D(0.0,windowWidth,0,windowHeight);
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
		glDisable(GL_LIGHTING);
		glColor3d(1,1,1);


		// Copyright
		glRasterPos2d(0.90*windowWidth,0.02*windowHeight);
		sprintf(textBuffer1,"(c) 2003 IMAC");
		DrawTools::drawText(textBuffer1,1);

		// fps
		if (showFps){
			sprintf(textBuffer1,"FPS: %2.1f",fps);
			glRasterPos2d(0.93*windowWidth,0.98*windowHeight);
			DrawTools::drawText(textBuffer1,2);
		}


	// aide
	if (aide){
		sprintf(textBuffer1,"KEYBOARD COMMANDS");
		glRasterPos2d(0.01*windowWidth,0.87*windowHeight);
		DrawTools::drawText(textBuffer1,2);
		sprintf(textBuffer1,"a : show/hide help");
		glRasterPos2d(0.01*windowWidth,0.84*windowHeight);
		DrawTools::drawText(textBuffer1,1);
		sprintf(textBuffer1,"q : quit");
		glRasterPos2d(0.01*windowWidth,0.82*windowHeight);
		DrawTools::drawText(textBuffer1,1);
		sprintf(textBuffer1,"f : show/hide fps");
		glRasterPos2d(0.01*windowWidth,0.80*windowHeight);
		DrawTools::drawText(textBuffer1,1);
		sprintf(textBuffer1,"t : show/hide textures");
		glRasterPos2d(0.01*windowWidth,0.78*windowHeight);
		DrawTools::drawText(textBuffer1,1);
		sprintf(textBuffer1,"s : show/hide spot positions");
		glRasterPos2d(0.01*windowWidth,0.76*windowHeight);
		DrawTools::drawText(textBuffer1,1);
		sprintf(textBuffer1,"r : reset");
		glRasterPos2d(0.01*windowWidth,0.74*windowHeight);
		DrawTools::drawText(textBuffer1,1);
		sprintf(textBuffer1,"1 : 4-spring-model");
		glRasterPos2d(0.01*windowWidth,0.72*windowHeight);
		DrawTools::drawText(textBuffer1,1);
		sprintf(textBuffer1,"2 : 8-spring-model");
		glRasterPos2d(0.01*windowWidth,0.70*windowHeight);
		DrawTools::drawText(textBuffer1,1);
		sprintf(textBuffer1,"3 : 4-spring-model (vertical movement only)");
		glRasterPos2d(0.01*windowWidth,0.68*windowHeight);
		DrawTools::drawText(textBuffer1,1);
		sprintf(textBuffer1,"4 : 4-spring-model (vertical movement only, Piranda version)");
		glRasterPos2d(0.01*windowWidth,0.66*windowHeight);
		DrawTools::drawText(textBuffer1,1);
		sprintf(textBuffer1,"5 : oceanographic model (vertical movement only)");
		glRasterPos2d(0.01*windowWidth,0.64*windowHeight);
		DrawTools::drawText(textBuffer1,1);
        	sprintf(textBuffer1,"directional keys : turn camera");
		glRasterPos2d(0.01*windowWidth,0.62*windowHeight);
		DrawTools::drawText(textBuffer1,1);
		sprintf(textBuffer1,"MOUSE COMMANDS");
		glRasterPos2d(0.01*windowWidth,0.57*windowHeight);
		DrawTools::drawText(textBuffer1,2);
		sprintf(textBuffer1,"left clic                  : create wave under clic (not implemented yet)");
		glRasterPos2d(0.01*windowWidth,0.54*windowHeight);
		DrawTools::drawText(textBuffer1,1);
		sprintf(textBuffer1,"left clic + move     : move camera");
		glRasterPos2d(0.01*windowWidth,0.52*windowHeight);
		DrawTools::drawText(textBuffer1,1);
		sprintf(textBuffer1,"right clic + move   : zoom");
		glRasterPos2d(0.01*windowWidth,0.50*windowHeight);
		DrawTools::drawText(textBuffer1,1);
        if (modele == 5){
            sprintf(textBuffer1,"PIERSON-MOSKOWITZ MODEL PARAMETERS");
		    glRasterPos2d(0.01*windowWidth,0.45*windowHeight);
		    DrawTools::drawText(textBuffer1,2);
            sprintf(textBuffer1,"wind direction: %.2f  (keys: y- x+)", ma_waterSurface3->GetWindDirection());
	    	glRasterPos2d(0.01*windowWidth,0.42*windowHeight);
		    DrawTools::drawText(textBuffer1,1);
            sprintf(textBuffer1,"wind speed : %.2f  (keys: c- v+)", ma_waterSurface3->GetWindSpeed());
    		glRasterPos2d(0.01*windowWidth,0.40*windowHeight);
	    	DrawTools::drawText(textBuffer1,1);
            sprintf(textBuffer1,"show wave number: %d  (keys: w)", ma_waterSurface3->GetCurrentWave());
    		glRasterPos2d(0.01*windowWidth,0.38*windowHeight);
	    	DrawTools::drawText(textBuffer1,1);
        }
	}

	   glEnable(GL_LIGHTING);
	glPopMatrix();
	glMatrixMode(GL_PROJECTION);
  glPopMatrix();

  // changement de buffer d'affichage
  glutSwapBuffers();
}



/*******************************************************\
* Fonction:		reshapeFunc                             *
* Description:  change la dimension de la fenetre		*
* Paramtres :                                          *
* - width : largeur (x) de la zone de visualisation     *
* - height : hauteur (y) de la zone de visualisation	*
\*******************************************************/
static void reshapeFunc(int w,int h){
  
  // Rapport entre largeur et hauteur de la fenetre
  windowRapport=(float)w/(float)h;

  // dimension de l'cran GL
  glViewport(0, 0, (GLint)w, (GLint)h);
  
  // construction de la matrice de projection
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  
  // dfinition de la camera
  gluPerspective(20.0,windowRapport,1.0,20.0 );
  
  // initialisation de la matrice de la scne
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}



/*******************************************************\
* Fonction:		kbdFunc									*
* Description:  fonction associe aux interruptions		*
*				clavier									*
* Paramtres :                                          *
* - c : caractre saisi                                 *
* - x,y : coordonne du curseur dans la fentre			*
\*******************************************************/
static void kbdFunc(unsigned char c, int x, int y){
  switch(c){
	// quitter le programme avec les touches ESC, 'q' ou 'Q'
	case 27 : case 'q' : case 'Q' :
		exit(0);
		break;
	// afficher l'aide
	case 'a' : case 'A' :
		aide = !aide;
		break;
	// afficher le nombre d'images par seconde
	case 'f' : case 'F' :
		showFps = !showFps;
		break;
	// texture (pour les ordinateurs qui rament comme le mien)
	case 't' : case 'T' :
		texture = !texture;
		break;
	// afficher les reperes des spots
	case 's' : case 'S' :
		reperesSpots = !reperesSpots;
		break;
	// changer le modele
	case '1' :
		ma_waterSurface->setK(0.5);
		ma_waterSurface->setFriction(0.990);
		ma_waterSurface->setModel(1);
		modele = 1;
		break;
	case '2' :
		ma_waterSurface->setK(0.1);
		ma_waterSurface->setFriction(0.9999);
		ma_waterSurface->setModel(2);
		modele = 1;
		break;	
	case '3' :
		ma_waterSurface->setK(0.5);
		ma_waterSurface->setFriction(0.990);
		ma_waterSurface->setModel(3);
		modele = 1;
		break;
	case '4' :
		modele = 4;
		break;
	case '5' :
		modele = 5;
		break;	
	// reset
	case 'r' : case 'R' :
		ma_waterSurface->reset();
		ma_waterSurface2->reset();
        ma_waterSurface3->reset();
		break;
    // paramtres du vent
	case 'y' : case 'Y' :
        ma_waterSurface3->SetWindDirection(ma_waterSurface3->GetWindDirection() - 0.1);
		break;
	case 'x' : case 'X' :
        ma_waterSurface3->SetWindDirection(ma_waterSurface3->GetWindDirection() + 0.1);
		break;
	case 'c' : case 'C' :
        ma_waterSurface3->SetWindSpeed(ma_waterSurface3->GetWindSpeed() - 0.1);
		break;
	case 'v' : case 'V' :
        ma_waterSurface3->SetWindSpeed(ma_waterSurface3->GetWindSpeed() + 0.1);
		break;
    // afficher que la vague numro x ou toutes les vagues
	case 'w' : case 'W' :
        ma_waterSurface3->SetCurrentWave(ma_waterSurface3->GetCurrentWave() + 1);
		break;
    // afficher les donnes des vagues
	case 'p' : case 'P' :
        ma_waterSurface3->PrintData();
		break;
  }
  glutPostRedisplay();
}



/*******************************************************\
* Fonction:		kbdSpecialFunc							*
* Description:  fonction associe aux interruptions		*
*				clavier									*
* Paramtres :                                          *
* - c : caractre saisi                                 *
* - x,y : coordonne du curseur dans la fentre			*
\*******************************************************/
static void kbdSpecialFunc(int c, int x, int y){
	switch (c){
		case GLUT_KEY_UP : phiOeil += 0.1; break;
		case GLUT_KEY_DOWN : phiOeil -= 0.1; break;
		case GLUT_KEY_RIGHT : thetaOeil += 0.1; break;
		case GLUT_KEY_LEFT : thetaOeil -= 0.1; break;
		case GLUT_KEY_PAGE_UP : distOeil *= 1.1; break;
		case GLUT_KEY_PAGE_DOWN : distOeil /= 1.1; break;
	}
	oeilx=distOeil*cos(thetaOeil)*cos(phiOeil);
	oeily=distOeil*sin(thetaOeil)*cos(phiOeil);
	oeilz=distOeil*sin(phiOeil);
	glutPostRedisplay();
}



/*******************************************************\
* Fonction:		mouseFunc								*
* Description:  fonction associe au clique de la		*
*				souris									*
* Paramtres :                                          *
* - button : nom du bouton press GLUT_LEFT_BUTTON,     *
*   GLUT_MIDDLE_BUTTON ou GLUT_RIGHT_BUTTON             *
* - state : tat du bouton button GLUT_DOWN ou GLUT_UP  *
* - x,y : coordonne du curseur dans la fentre      	*
\*******************************************************/
static void mouseFunc(int button, int state, int x, int y){
  if(state == GLUT_DOWN && button == GLUT_LEFT_BUTTON){
     // selectioner
     //selection(x,y);
     xold=x;
     yold=y;
     left=true;
     right=false;
  }
  else if(state == GLUT_DOWN && button == GLUT_RIGHT_BUTTON){
     // zoomer
     y_zoom_old=y;
     left=false;
     right=true;

  }
}


/*******************************************************\
* Fonction:		motionFunc								*
* Description:  fonction associe au dplacement de la	*
*				souris bouton enfonc					*
* Paramtres :                                          *
* - x,y : coordonne du curseur dans la fentre			*
\*******************************************************/
static void motionFunc(int x, int y){
   if(left){
      dist_x = xold - x;
      dist_y = yold - y;

      // On ne tient pas compte des petites variations du curseur
      if(abs(dist_x)<=20){
         dist_x=0;
      }
      if(abs(dist_y)<=20){
         dist_y=0;
      }

      thetaOeil += dist_x*0.001;
      phiOeil += dist_y*0.001;

      x=xold;
      y=yold;
   }
   else if(right){
      dist_yzoom = y_zoom_old - y;
      zoom += (dist_yzoom*0.0001);
      if (zoom < 0) zoom = 0;

      // pour un zoom 'rel' de la camra:
      // distOeil += (dist_yzoom*0.001);
   }

   oeilx=distOeil*cos(thetaOeil)*cos(phiOeil);
   oeily=distOeil*sin(thetaOeil)*cos(phiOeil);
   oeilz=distOeil*sin(phiOeil);
   glutPostRedisplay();
}



/*******************************************************\
* Fonction:		idleFunc								*
* Description:  fonction excute par OpenGL lorsqu'il	*
*				n'y a pas de traitement d'affichage 	*
*				raliser. 								*
\*******************************************************/
static void idleFunc(){
  
  // calcul du temps coul (en millisecondes)
  GLdouble deltaTemps = glutGet(GLUT_ELAPSED_TIME)-temps;

  // fps
  fps = 1 / (deltaTemps/1000);

  // sauvegarde du temps actuel
  temps = glutGet(GLUT_ELAPSED_TIME);

  // reaffichage
  glutPostRedisplay();
}



/*******************************************************\
* Fonction:		dessinerSceneNommee						*
* Description:  fonction de dessin de la scne			*
*				cliquable  								*
\*******************************************************/
void dessinerSceneNommee(){
}



/*******************************************************\
* Fonction:		processHits								*
* Description:  fonctionnement du traitement de la		*
*				slection des objets. nmini contient le	*
*				numro de l'lment slectionn (celui	*
*				de z minimum) et hits le nombre des		*
*				lments se trouvant "sous" le clic		*
\*******************************************************/
void processHits(GLint hits, GLuint buffer[]){

   GLuint names, *ptr, zmini, nmini=-1;

   ptr = (GLuint *) buffer;

   names = ptr[0];
   zmini = ptr[1];
   // ptr[2] contient la profondeur maximale
   nmini = ptr[3];

}



/*******************************************************\
* Fonction:		selection								*
* Description:  fonction de slection des objets		*
*				en-dessous du curseur   				*
\*******************************************************/
void selection(int x, int y){
  GLuint selectBuf[_SELECTION_BUFFER_SIZE];
  GLint hits;
  GLint viewport[4];

  glGetIntegerv(GL_VIEWPORT,viewport);
  glSelectBuffer(_SELECTION_BUFFER_SIZE,selectBuf);
  glRenderMode(GL_SELECT);

  // initialisation de la pile de son nom (-1 nom par dfaut)
  glInitNames();
  glPushName(-1);

  // mise en place de la matrices de projection (cohrente avec l'affichage)
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity();

  // filtrage de la zone de slection (ici un bloc de 9 pixel centrs sur x,y)
  gluPickMatrix((float) x, (float) (viewport[3]-y),3.0,3.0,viewport);
  gluPerspective(20.0,windowRapport,1.0,20.0);

  // mise en place de la matrice de modlisation (cohrente avec l'affichage)
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glLoadIdentity();


  // il faut ici dessiner la scne en nommant les lments slectionnables
  // placement de la scne en fonction de la camra
  gluLookAt(oeilx,oeily,oeilz,visex,visey,visez,0.0,0.0,1.0);
  // Zoom
  glScalef(zoom,zoom,zoom);
  dessinerSceneNommee();
  // fin de la partie 3D. Voir plus haut "modification de la matrice de la projection"
  glPopMatrix();

  glMatrixMode(GL_PROJECTION);
  glPopMatrix();
  glFlush();
  hits = glRenderMode(GL_RENDER);
  processHits(hits, selectBuf);
}



/*******************************************************\
* Fonction:		init									*
* Description:  fonction d'initialisation des			*
*				paramtres de rendu et  des objets de	*
*				la scnes.   							*
\*******************************************************/
static void init(){
  // couleur du fond (noir)
  glClearColor(0.05,0.05,0.05,0.0);

  // activation du ZBuffer
  glEnable(GL_DEPTH_TEST);

  // lumieres
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);   // lumire globale diffuse (il fait noir dans un moteur!)

  // normalisation
  glEnable(GL_NORMALIZE);

  // lissage des couleurs sur les facettes
  glShadeModel(GL_SMOOTH);

  // objets
  mon_repere = new Repere();
  ma_waterSurface = new WaterSurface(40,30);
  ma_waterSurface2 = new WaterSurface2(40,30);
  ma_waterSurface3 = new WaterSurface3(128,128);
}



/*******************************************************\
* Fonction:		credits									*
* Description:  affiche un texte dans la console lors	*
*				du dmarrage							*
\*******************************************************/
void credits (void){
  cout<<"                         *********************************"<<endl
      <<"                               Projet: Surface d'eau"<<endl
      <<"                            Georges AZZI / Georges CAMY"<<endl
      <<"                           Julie POULETTY / Arnaud QUENUM"<<endl
      <<"                              IHM / Animation - OPEN GL "<<endl
      <<"                                       IMAC 3   "<<endl
      <<"                         *********************************"<<endl;
}


/*******************************************************\
*                      main                             *
\*******************************************************/
int main(int argc, char** argv){
  //credit
  credits();

  // traitement des paramtres du programme propres  GL
  glutInit(&argc, argv);

  // initialisation du mode d'affichage :
  // RVB + Double buffer.
  glutInitDisplayMode(GLUT_RGBA|GLUT_DEPTH|GLUT_DOUBLE);

  // placement et dimentions initiales de la fentre
  glutInitWindowPosition(0, 0);
  glutInitWindowSize(windowWidth,windowHeight);

  // ouverture de la fentre de visualisation 3D
  if (glutCreateWindow("Tempte sur mer...") == GL_FALSE)
  { 
  	  return 1;
  }
  //glutEnterGameMode();

  init();

  // association de la fonction de dimensionnement
  glutReshapeFunc(reshapeFunc);
  // association de la fonction d'affichage
  glutDisplayFunc(drawFunc);
  // association des fonctions d'vnement du clavier
  glutKeyboardFunc(kbdFunc);
  glutSpecialFunc(kbdSpecialFunc);
  // association de la fonction d'vnement souris
  glutMouseFunc(mouseFunc);
  // association de la fonction de DRAG
  glutMotionFunc(motionFunc);
  // association de la fonction d'animation
  glutIdleFunc(idleFunc);

  // boucle principale de gestion des vnements 
  glutMainLoop();

  return 0;
}